	PROGRAM BT3_10
	REAL N, ALFA, X0
	WRITE(*,'(A\)')' CHO MUC Y NGHIA ALPHA: '
	READ(*,*) ALFA
	WRITE(*,'(A\)')' CHO SO BAC TU DO N   : '
	READ(*,*) N
	X0=CHINV(ALFA,N)
	WRITE(*,'(" GIA TRI X0 = ",F12.4)') X0
	END

	FUNCTION CHINV(P,N)
! HAM NAY TINH GIA TRI X0 CUA BIEN NGAU NHIEN X PHAN BO 
! "KHI BINH PHUONG" VOI N BAC TU DO THOA MAN DIEU KIEN 
! P(X>X0)=P.
! INPUT: + P XAC SUAT DE X>X0 (P(X>X0)=P)
!        + N SO BAC TU DO, PHAI LA MOT SO THUC
! OUTPUT: X0
! SUBROUTINE/FUNCTION DUOC GOI TOI: CHIDIST
	PARAMETER (EPS=1.0E-6)
	REAL P,AP,N, A,B,C,P0

	  IF (P.LT.0.0.OR.P.GT.1.0) THEN
	     WRITE(*,*)' INVALID NUMERIC INPUT IN AKBPINV FUNCTION'
		 STOP
	  ENDIF
	  IF (P.EQ.0.0) THEN
		 CHINV=0.0
		 RETURN
	  ELSE IF (P.EQ.1) THEN
	     WRITE(*,*)' THE P VALUE TOO BIG IN AKBPINV FUNCTION'
		 STOP
	  ENDIF
!
	  A=0.0
	  B=9999999.0
	  C=A
	  AP=P
	  PRINT*,P,A,B,C

 10	  P0=CHIDIST(B,N)
	  SS=ABS((P0-AP)/AP)
	  SS1=ABS((B-C)/B)
	  PRINT*,'P0=',P0,' SS=',SS,' B=',B,' C=',C
	  IF (SS.GE.EPS.AND.SS1.GE.EPS) THEN
	     IF (AP.GT.P0) THEN
		    C=B
			B=(A+B)/2.0
			GOTO 10
		  ELSE IF (AP.LT.P0) THEN
			B=(C+B)/2.0
			GOTO 10
		  ENDIF
	  ENDIF
	  A=(C+B)/2.0
      CHINV=A
	  RETURN
	  END


	FUNCTION CHIDIST(X0,N)
! HAM NAY TINH XAC SUAT P=P(X>0) VOI X LA BIEN NGAU NHIEN
! CO PHAN BO "KHI BINH PHUONG" VOI N BAC TU DO.
! INPUT: + X0 MOT GIA TRI NAO DO CUA X
!        + N BAC TU DO
! OUTPUT: P=P(X>X0)
! SUBROUTINE/FUNCTION DUOC GOI TOI: GAMMQ
      REAL X0,N
	CHIDIST=GAMMQ(N/2.0,X0/2.0)
	RETURN
	END

      FUNCTION gammq(a,x)
      REAL a,gammq,x
!CU    USES gcf,gser
      REAL gammcf,gamser,gln
      if(x.lt.0..or.a.le.0.)pause 'bad arguments in gammq'
      if(x.lt.a+1.)then
        call gser(gamser,a,x,gln)
        gammq=1.-gamser
      else
        call gcf(gammcf,a,x,gln)
        gammq=gammcf
      endif
      return
      END

      SUBROUTINE gcf(gammcf,a,x,gln)
      INTEGER ITMAX
      REAL a,gammcf,gln,x,EPS,FPMIN
      PARAMETER (ITMAX=100,EPS=3.e-7,FPMIN=1.e-30)
!CU    USES gammln
      INTEGER i
      REAL an,b,c,d,del,h,gammln
      gln=gammln(a)
      b=x+1.-a
      c=1./FPMIN
      d=1./b
      h=d
      do 11 i=1,ITMAX
        an=-i*(i-a)
        b=b+2.
        d=an*d+b
        if(abs(d).lt.FPMIN)d=FPMIN
        c=b+an/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1./d
        del=d*c
        h=h*del
        if(abs(del-1.).lt.EPS)goto 1
11    continue
      pause 'a too large, ITMAX too small in gcf'
1     gammcf=exp(-x+a*log(x)-gln)*h
      return
      END


      SUBROUTINE gser(gamser,a,x,gln)
      INTEGER ITMAX
      REAL a,gamser,gln,x,EPS
      PARAMETER (ITMAX=100,EPS=3.e-7)
!CU    USES gammln
      INTEGER n
      REAL ap,del,sum,gammln
      gln=gammln(a)
      if(x.le.0.)then
        if(x.lt.0.)pause 'x < 0 in gser'
        gamser=0.
        return
      endif
      ap=a
      sum=1./a
      del=sum
      do 11 n=1,ITMAX
        ap=ap+1.
        del=del*x/ap
        sum=sum+del
        if(abs(del).lt.abs(sum)*EPS)goto 1
11    continue
      pause 'a too large, ITMAX too small in gser'
1     gamser=sum*exp(-x+a*log(x)-gln)
      return
      END

      FUNCTION gammln(xx)
      REAL gammln,xx
      INTEGER j
      DOUBLE PRECISION ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0, 
     & 24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2, 
     & -.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5d0)*log(tmp)-tmp
      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
      gammln=tmp+log(stp*ser/x)
      return
      END
